import { HttpClient } from '@angular/common/http';
import { Observable } from 'rxjs';
import { ConfigService } from './config.service';
import * as i0 from "@angular/core";
export interface InitConfig {
    /**
     * @type Environments
     */
    'config.base.json': false;
    /**
     * @type Environments
     */
    'config.json': true;
}
export declare class InitService {
    private readonly _configService;
    private readonly _http;
    static _configOverrides: Map<string, keyof InitConfig>;
    static readonly configOverridesKey = "CONFIG_OVERRIDES";
    private static readonly configs;
    private _configs;
    constructor(_configService: ConfigService, _http: HttpClient);
    static get configOverrides(): Map<string, keyof InitConfig>;
    get configOverrides(): Map<string, keyof InitConfig>;
    static construct(): void;
    private static saveLocalStorage;
    initConfigs(): Observable<void>;
    addConfigOverride(key: string, config: keyof InitConfig): void;
    removeConfigOverride(key: string): void;
    private overrideConfig;
    static ɵfac: i0.ɵɵFactoryDeclaration<InitService, never>;
    static ɵprov: i0.ɵɵInjectableDeclaration<InitService>;
}
