import { EventDelegate, ObjectBase } from '../mvvm';
import { LogTypes } from './log-types';
import { LoggedEventArgs } from './logged-event-args';
export declare class LogService extends ObjectBase {
    #private;
    readonly logged: EventDelegate<LogService, LoggedEventArgs>;
    private _logs;
    private _trace;
    private readonly _consoleLogFunctions;
    constructor();
    static get instance(): LogService;
    get logs(): Array<LoggedEventArgs>;
    get trace(): boolean;
    set trace(value: boolean);
    extendLogging(logType: LogTypes): void;
    save(type: 'text' | 'json', filename?: string): void;
    restoreLogs(): void;
    logsAvailable(...types: Array<LogTypes>): boolean;
    private addLog;
    private saveLogs;
}
