import { EventArgs } from '../mvvm';
import { LogTypes } from './log-types';
export interface ILoggedEventArgs {
    date: Date;
    type: LogTypes;
    message: string;
    data: Array<unknown>;
}
export declare class LoggedEventArgs extends EventArgs implements ILoggedEventArgs {
    readonly type: LogTypes;
    readonly message: string;
    private readonly _data;
    private _date;
    constructor(type: LogTypes, message: string, ...data: Array<unknown>);
    get data(): Array<unknown>;
    get date(): Date;
    static fromJSON(o: ILoggedEventArgs): LoggedEventArgs;
    toJSON(): ILoggedEventArgs;
    toString(): string;
}
