import { HttpRequest } from '@angular/common/http';
import { Observable } from 'rxjs';
import { MockApiReplyCallback } from './mock-api.types';
export declare class MockApiHandler {
    url: string;
    delay?: number;
    request: HttpRequest<any>;
    urlParams: {
        [key: string]: string;
    };
    private _reply;
    private _replyCount;
    private _replied;
    /**
     * Constructor
     */
    constructor(url: string, delay?: number);
    /**
     * Getter for response callback
     */
    get response(): Observable<any>;
    /**
     * Reply
     *
     * @param callback
     */
    reply(callback: MockApiReplyCallback): void;
    /**
     * Reply count
     *
     * @param count
     */
    replyCount(count: number): void;
}
