import { AfterContentChecked, AfterContentInit, AfterViewChecked, AfterViewInit, OnChanges, OnDestroy, OnInit, SimpleChanges } from '@angular/core';
import { ObjectModel } from '@awesome-nodes/mvvm/model';
import { ComponentBase as Base } from '@awesome-nodes/mvvm/view';
import { IViewModel } from '@awesome-nodes/mvvm/view-model';
import * as i0 from "@angular/core";
export { SimpleChanges };
/**
 * Represents the object base for all ngx components within the model-view-view-model pattern.
 * Keep this as clean as possible from specialized code to be able to migrate to future ngx versions.
 */
export declare abstract class ComponentBase<TViewModel extends IViewModel<TModel>, TModel extends ObjectModel = ObjectModel> extends Base<TViewModel, TModel> implements OnInit, OnDestroy, AfterViewInit, AfterViewChecked, AfterContentInit, AfterContentChecked, OnChanges {
    protected constructor(vm: TViewModel);
    /**
     * Returns the view-model instance associated with this component instance.
     */
    get vm(): TViewModel;
    get model(): TModel;
    set Model(value: TModel);
    /** @inheritDoc */
    ngOnInit(): void;
    /** @inheritDoc */
    ngOnDestroy(): void;
    /** @inheritDoc */
    ngAfterViewInit(): void;
    /** @inheritDoc */
    ngAfterViewChecked(): void;
    /** @inheritDoc */
    ngAfterContentInit(): void;
    /** @inheritDoc */
    ngAfterContentChecked(): void;
    /** @inheritDoc */
    ngOnChanges(changes: SimpleChanges): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<ComponentBase<any, any>, never>;
    static ɵprov: i0.ɵɵInjectableDeclaration<ComponentBase<any, any>>;
}
