import { HttpClient } from '@angular/common/http';
import { EntityFilter, QueryResult, CachedRepoAspect } from '@yukawa/chain-base-angular-domain';
import { MonoTypeOperatorFunction, Observable, Subject } from 'rxjs';
import { ConfigService } from '../config/config.service';
import { InterceptedRepoAspectsRest } from './intercepted-repo-aspects-rest';
export declare class CachedRepoAspectRest<K, V, F extends EntityFilter> extends InterceptedRepoAspectsRest<K, V, F> implements CachedRepoAspect<K, V, F> {
    private readonly _filterCache;
    private readonly _keyExtractor;
    private readonly _idCache;
    private readonly _idCacheRefreshSubjects;
    constructor(http: HttpClient, configService: ConfigService, urlKey: string, keyExtractor: (entity: V) => K);
    protected findQueryCacheKey(filter: F): F;
    protected removeQueryCache(filter: F): boolean;
    query(filter: F): Observable<QueryResult<V>>;
    load(key: K): Observable<V>;
    update(entity: V): Observable<V>;
    merge(entity: V): Observable<V>;
    put(entity: V): Observable<V>;
    edit(entity: V): Observable<V>;
    refreshOp(entity: V): MonoTypeOperatorFunction<V>;
    refresh(): void;
    refreshCaches(entity: V): void;
    getCachedEntityObservable(key: K): Observable<V>;
    getRefreshSubject(key: K): Subject<void>;
    refreshEntityCache(key: K): void;
    refreshQueryCache(filter?: F): void;
}
