import { EntityFilter, QueryResult } from '@yukawa/chain-base-angular-domain';
import { Observable } from 'rxjs';
import { PlainObject } from 'simplytyped';
import { CachedRepoAspectRest } from './cached-repo-aspect-rest';
import { Entity } from './entity';
import { EntityKey, EntityRepository } from './entity-repository';
export declare abstract class CachedRepoEntityService<TEntity extends Entity, TFilter extends EntityFilter, TKey extends EntityKey> extends CachedRepoAspectRest<TKey, TEntity, TFilter> {
    readonly repository: EntityRepository<TEntity>;
    load(key: TKey): Observable<TEntity>;
    find(filter: TFilter): Observable<TEntity[]>;
    query(filter: TFilter): Observable<QueryResult<TEntity>>;
    put(entity: TEntity): Observable<TEntity>;
    create(entity: TEntity): Observable<TEntity>;
    update(entity: TEntity): Observable<TEntity>;
    merge(entity: TEntity): Observable<TEntity>;
    edit(entity: TEntity): Observable<TEntity>;
    deleteByKey(key: TKey): Observable<TEntity>;
    delete(entity: TEntity): Observable<TEntity>;
    deleteAll(filter: TFilter): Observable<TEntity[]>;
    all(): Observable<Array<TEntity>>;
    add(key: TKey): Observable<TEntity>;
    remove(key: TKey): Observable<TEntity>;
    protected keyForEntityCache?(json: TEntity): string;
    protected abstract createInstanceFrom(json: PlainObject, other?: PlainObject): TEntity;
}
