import { RepoAspectRest } from "./repo-aspect-rest";
import { Observable } from "rxjs";
import { InterceptedRepoAspect, QueryResult } from "@yukawa/chain-base-angular-domain";
import { HttpClient } from "@angular/common/http";
import { ConfigService } from "../config/config.service";
export declare class InterceptedRepoAspectsRest<K, V, F> extends RepoAspectRest<K, V, F> implements InterceptedRepoAspect<K, V, F> {
    constructor(http: HttpClient, configService: ConfigService, urlKey: string);
    load(key: K): Observable<V>;
    find(filter: F): Observable<V[]>;
    query(filter: F): Observable<QueryResult<V>>;
    create(entity: V): Observable<V>;
    update(entity: V): Observable<V>;
    merge(entity: V): Observable<V>;
    put(entity: V): Observable<V>;
    deleteByKey(key: K): Observable<V>;
    beforeLoad(key: K): Observable<K>;
    beforeRead(filter: F): Observable<F>;
    beforeWrite(entity: V): Observable<V>;
    beforeDelete(key: K): Observable<K>;
    afterLoad(entity: V): Observable<V>;
    afterRead(entity: V): Observable<V>;
    afterQuery(result: QueryResult<V>): Observable<QueryResult<V>>;
    afterWrite(entity: V): Observable<V>;
    afterDelete(entity: V): Observable<V>;
}
