import { QueryResult, RepoAspect } from "@yukawa/chain-base-angular-domain";
import { Observable } from "rxjs";
import { ConfigService } from "../config/config.service";
import { HttpClient } from "@angular/common/http";
/**
 * ts impl of inc.yukawa.chain.base.rest.ctrl.RepoAspectRest
 */
export declare class RepoAspectRest<K, V, F> implements RepoAspect<K, V, F> {
    protected http: HttpClient;
    protected configService: ConfigService;
    protected urlKey: string;
    constructor(http: HttpClient, configService: ConfigService, urlKey?: string);
    get verbose(): boolean;
    protected formatServiceUrl(path?: string): string;
    load(key: K): Observable<V>;
    count(filter: F): Observable<number>;
    find(filter: F): Observable<V[]>;
    findKeys(filter: F): Observable<K[]>;
    query(filter: F): Observable<QueryResult<V>>;
    put(entity: V): Observable<V>;
    create(entity: V): Observable<V>;
    update(entity: V): Observable<V>;
    merge(entity: V): Observable<V>;
    edit(entity: V): Observable<V>;
    deleteByKey(key: K): Observable<V>;
    delete(entity: V): Observable<V>;
    deleteAll(filter: F): Observable<V[]>;
}
