import { HttpErrorResponse } from '@angular/common/http';
import { Renderer2 } from '@angular/core';
interface Script {
    kind: 'css' | 'javascript';
    url: string;
    loaded: boolean;
}
declare class ScriptStore {
    #private;
    get keys(): Array<string>;
    add(kind: 'css' | 'javascript', name: string, url: string): Script;
    contains(name: string): boolean;
    get(playerName: string): Script;
}
export interface ScriptLoadingStatus {
    script: string;
    loaded: boolean;
    error?: HttpErrorResponse;
}
export declare class LoadScriptService {
    #private;
    get scriptStore(): ScriptStore;
    loadScripts(renderer: Renderer2): Promise<Array<ScriptLoadingStatus>>;
    loadScript(name: string, renderer: Renderer2): Promise<ScriptLoadingStatus>;
}
export {};
