import { PlainObject } from 'simplytyped';
/**
 * Returns a time format like "1:01" or "4:03:59" or "123:03:59"
 *
 * @param time The time as unix timestamp.
 * @param round
 */
export declare const timeFormat: (time: number, round?: boolean) => string;
/**
 * Updates the list indexes with only updated items.
 *
 * @param list
 * @param items
 */
export declare const updateList: <T>(list: T[], items: T[]) => void;
export declare const enumKeys: <O extends object, K extends keyof O = keyof O>(obj: O) => K[];
/**
 * Removes `undefined` object entries recursively.
 *
 * @param  obj
 */
export declare const removeEmpty: <T extends PlainObject = PlainObject>(obj: T) => T;
/**
 * Generates a random id
 *
 * @param length
 */
export declare const randomId: (length?: number) => string;
